import { Extension, SelectionRange } from "@codemirror/state";
import type { EditorView, ViewUpdate } from "@codemirror/view";
export interface Range {
    anchor: number;
    head: number;
}
export declare const FakeSelection: import("@codemirror/state").StateEffectType<Range>;
interface DrawSelection {
    cursorLayer: HTMLDivElement;
    measureReq: {
        read: () => {
            cursors: {
                draw: () => HTMLDivElement;
            }[];
        };
        write: () => unknown;
    };
    range: SelectionRange;
    update(update: ViewUpdate): void;
    view: EditorView;
}
/**
 * CodeMirror extension to imitate selections.
 * @param drawSelection CodeMirror extension to modify.
 */
export declare function fakeSelection(drawSelection: Extension[]): (view: EditorView) => DrawSelection;
export {};
